# @file  ihost.py
#

###################################################
# E2 GUI COMMPONENTS 
###################################################
import os,re,sys,urllib,urllib2,traceback,ast
import xml.etree.cElementTree
import cookielib
import time
############################
from addonsParser.tsiplayer.libs.vstream.requestHandler import cRequestHandler
from addonsParser.tsiplayer.libs.vstream.config import GestionCookie
from addonsParser.components.addonsParserinit import TranslateTXT as _, GetIPTVNotify,GetIPTVSleep
from addonsParser.libs.urlparserhelper import unpackJSPlayerParams, unpackJS, \
                                                               JS_FromCharCode, \
                                                               JS_toString, \
                                                               VIDUPME_decryptPlayerParams,    \
                                                               SAWLIVETV_decryptPlayerParams,  \
                                                               TEAMCASTPL_decryptPlayerParams, \
                                                               VIDEOWEED_decryptPlayerParams, \
                                                               KINGFILESNET_decryptPlayerParams, \
                                                               captchaParser, \
                                                               getDirectM3U8Playlist, \
                                                               getMPDLinksWithMeta, \
                                                               getF4MLinksWithMeta, \
                                                               decorateUrl, \
                                                               int2base, drdX_fx, \
                                                               unicode_escape
from addonsParser.tools.iptvtypes import strwithmeta
from addonsParser.components.asynccall import MainSessionWrapper
from addonsParser.libs.pCommon import common, CParsingHelper
#from addonsParser.libs.urlparser import urlparser
from addonsParser.tools.iptvtools import getDownloadPath,getCachePath,getAppTmp,getAppDukPath,getAppPath,CSearchHistoryHelper, GetCookieDir, printDBG, printExc, GetLogoDir, byteify,MergeDicts
from addonsParser.libs.e2ijson import loads as json_loads, dumps as json_dumps
from addonsParser.libs import ph
from addonsParser.tools.e2ijs import js_execute
from urlparse import urljoin

###############TSmedia stuff######################
def getAppPath():
    return __file__.split("/scripts")[0]
AppPath=getAppPath()
plugin_path=AppPath
def getos():
    if AppPath.startswith('/usr'):
        return 'enigma2'
    else:
        return 'windows'

if getos()=='enigma2':
   data_file='/tmp/TSmedia/data.json'
   log_file='/tmp/TSmedia_log'
   searchtext_file='/tmp/TSmedia/searchSTR'
else:
   data_file=AppPath+'/tmp/json.txt'
   log_file=AppPath+'/tmp/TSmedia_log'
   searchtext_file=AppPath+'/tmp/xbmc_search.txt'
def enigmaos():
    if os.path.exists('/var/lib/dpkg/status'):
        return 'oe2.2'
    else:
        return 'oe2.0'
    
class Item(object):
    def __init__(self,module_path=None):

        self.list=[]
        self.spath=sys.argv[0]
        self.addon_id=self.spath.split("/")[-2]
        self.section_id=self.spath.split("/")[-3]
        self.addonSPath=self.section_id+"/"+self.addon_id
        #self.__dict__ = self.toutf8(self.__dict__)
    def addDir(self,name='', url='', mode=0, image='',category='',page=1,maintitle = False, link = False,desc='', extra={},show='', searchall = None,type='',dialog=None,parseM3u8=True,headers=None,mediaType='video'):
            category=str(category)

           
           
            m3u8=False
            if name and  name.startswith("Error") :
                mode=-1
                if not dialog:
                   dialog="error"
            if url and name and ("error" in url or "error" in name.lower()) and mode==0 :
                mode=-1
                if not dialog:
                   dialog="error"
                name="Error:"+name               
            if name and mode==-1 :
                if not dialog:
                   dialog="error"
                name="Error:"+name
               
            if name and  (name.startswith("Message") or str(url).startswith("Message")):
                mode=-2
                if not dialog:
                   dialog='message'
                name=name.replace("Message:","")
            if name and mode==-2 and not name.startswith("Message"):
                if not dialog:
                    dialog='message'
                name="Message:"+name 
                
            if mode==-5 :
                m3u8=True
                mode=0


                
            if url and ('m3u8' in url) :
               m3u8=True 
            if mode==-6:
                m3u8=False 
                mode=0       
            if link==True:
                mode=0
            if mode==0:
                link=True
          
                
            if mode==503:
                if not dialog:
                   dialog="input"
            if mode==903:
                if not dialog:
                   dialog="login"                
            if mode==103 or mode==603 or mode==703 or mode==803 or mode==1003 or mode==2003:
                if not dialog:
                   dialog="search"                  
            if (url.startswith('plugin://plugin.video.youtube') or 'https://www.youtube.com/watch?v=' in url):
                             link=True
                             mode=0
            if image.startswith("img/"):
                image=AppPath+"/addons/"+self.addonSPath+"/"+image
               
            if not image.startswith("http") and not os.path.exists(image):
               image=AppPath+"//"+self.addonSPath+"/icon.png"  
            imageBasename=getimage_basename(image)



                  

            
            try:
                name = name.encode('utf-8', 'ignore')
                name=name.replace("'",'').replace("&"," ")
               
            except:
                pass             
            try:
                category = category.encode('utf-8', 'ignore')
                category=category.replace("'",'').replace("&"," ")
            except:
                pass              
            try:
                desc = desc.encode('utf-8', 'ignore')
                desc=desc.replace("'",'').replace("&"," ")
            except:
                pass                
            

            try:image = image.encode('utf-8', 'ignore')
            except:pass 
            try:url = url.encode('utf-8', 'ignore')
            except:pass
            m3u8add=False
            if m3u8==True and parseM3u8==True :
                try:
                    
                    from m3u8player import getm3u8playlist
                    list = getm3u8playlist(url)
                    for item in list:
                            url = str(item[1])
                            
                            try:             
                                title ='quality'+"-"+ str(item[0]).encode('utf-8', 'replace')
                                
                            except:
                                title=item[0]
                            cParams={}   
                            cParams['name']=title
                            cParams['title']=title
                            cParams['url']=url
                            cParams['mode']=0
                            cParams['image']=image
                            cParams['category']=category
                            cParams['page']=page
                            cParams['maintitle']=maintitle
                            cParams['desc']=desc
                            cParams['extra']=extra
                            cParams['type']=type
                            cParams['show']=show
                            cParams['caddon_id']=self.addon_id
                            cParams['csection_id']=self.section_id
                            cParams['dialog']=dialog
                            cParams['imageBasename']=imageBasename
                            if headers:
                               cParams['headers']=headers
                            


                            
                            self.list.append(cParams)
                            m3u8add=True
                                                
                       



                except:
                        
                        pass
            

            if m3u8add:
                return
            cParams={}   
            cParams['name']=name
            cParams['title']=name
            cParams['url']=url
            cParams['mode']=mode
            cParams['image']=image
            cParams['category']=category
            cParams['page']=page
            cParams['maintitle']=maintitle
            cParams['desc']=desc
            cParams['extra']=extra
            cParams['type']=type
            cParams['show']=show
            cParams['caddon_id']=self.addon_id
            cParams['csection_id']=self.section_id
            cParams['dialog']=dialog
            cParams['imageBasename']=imageBasename
            cParams['mediaType']=mediaType
            if headers:
               cParams['headers']=headers

            self.list.append(cParams)

            printD('cParams["title"]',cParams['title'])
            if searchall is not None and dialog=='search':
                try: 
                    dirname = os.path.split(searchall)[0]
                    addon_name = os.path.basename(dirname)
                    search_file = searchall.replace('default.pyc', 'searchall').replace('default.pyo', 'searchall').replace('default.py', 'searchall')
                    afile = open(search_file, 'w')
                    
                    afile.write(addon_name + ';;' + str(cParams))
                    afile.close()
                except:
                    pass            





    def getsearchtext(self,marker = '+'):
            import os
            if os.path.exists(searchtext_file):
                file = open(searchtext_file, 'r')
                sstr = file.read().replace(' ', marker)
                file.close()
            else:
                sstr = None
            return sstr
    
    def getHostName(self, url, nameOnly = True):
        hostName = strwithmeta(url).meta.get('host_name', '')
        print "hostName",hostName
        if not hostName:
            match = re.search('https?://(?:www.)?(.+?)/', url)
            if match:
                hostName = match.group(1)
                if (nameOnly):
                    n = hostName.split('.')
                    try: hostName = n[-2]
                    except Exception: printExc()
            hostName = hostName.lower()
        printDBG("_________________getHostName: [%s] -> [%s]" % (url, hostName))
        return hostName
    def getDomain(self,url):###
        hostName=self.getHostName(url)  
        
        
        issupported=supported(hostName)
        image=getserver_image(hostName)
        
        return hostName,image,issupported        

    def endDir(self):

            datalist=self.list
            printD("datalist-itools",datalist)                
            self.list=[]
            try:                 
                debugmode=sys.argv[3]
            except:
                printE()
                debugmode='user'
                
              
            
            printD('itools-debugmode',debugmode) 
            if debugmode=='developer':
                                
                  
                 try:
                    f=open(data_file,"w")
                    for item in datalist:
                        f.write(str(item)+"\n")
                    f.close()            
                        
                 except:
                     print ">>>Error storing output data to json file,check error>>"
                     printE()
                     return

            if debugmode=="SearchAll":
                f=open(data_file,"w")
                f.close()

                
   

                
            self.list=[]
            return datalist 

                   
       
    def resolvehost(self,name=None,url=None,headers=None):
                 
        from urlresolver import resolve

        
            
        if name=='':
               name='play'
        if "youtube" in url:
            stream_link=get_youtube_link(url)
        else:    
            stream_link=resolve(url)        
        
        if not stream_link :
            
            self.addDir("Error:invalid stream_link","Error:invalid stream_link",-1,"",name,1,headers=headers)
            return stream_link
        
        if  type(stream_link)==type([]):
          
           
           for ditem in stream_link:

               
               name=str(ditem[0])
               url=str(ditem[1])
               self.addDir(name,url,0,"",name,1,link=True,headers=headers)
           return  stream_link

        if stream_link.startswith("Error") or name.startswith("Error"):
           self.addDir(stream_link,stream_link,-1,"",name,1,headers=headers)
           return stream_link
            
        
        try:self.addDir(name,stream_link,0,'',name,1,headers=headers)
        except: printE()
        return stream_link	                  


        
    def get_params(self,params=None):
        if params and isinstance(params,dict):
            return params
        item=sys.argv[2]
        params={}
        try:
            item=item.replace('"','')
            params=ast.literal_eval(item)
            
            return params
        except:
           printE() 
           pass

        
        item = item.replace('AxNxD', '&').replace('ExQ', '=')
        paramstring = item
        if len(paramstring) >= 2:
            
            cleanedparams = paramstring.replace('?', '&')

            pairsofparams = cleanedparams.split('&')
            
            for i in range(len(pairsofparams)):
                splitparams = {}
                splitparams = pairsofparams[i].split('=')
                if len(splitparams) == 2:
                    p=splitparams[1]  
                    if isinstance(splitparams[1], basestring) :
                        p=urllib.unquote_plus(splitparams[1])
                    
                           
                    params[splitparams[0]] = p
        return params            



###################################################    
'''
CHostBase implements some typical methods
          from IHost interface
'''

    

class CBaseAddonClass(Item):
    def __init__(self, params={}):
        Item.__init__(self)
        self.ItemClass=Item()
        self.sessionEx = MainSessionWrapper() 
        #self.up = urlparser()
        
        proxyURL = params.get('proxyURL', '')
        useProxy = params.get('useProxy', False)
        self.cm = common(proxyURL, useProxy)

        self.currList = []
        self.currItem = {}
        if '' != params.get('cookie', ''):
            self.COOKIE_FILE = GetCookieDir(params['cookie'])
        self.moreMode = False
        
    def getTorrentInfo(self,torrentFile=None,tHash=None,extra={}):
            try:
                if getos()=="windows":
                    target="E://"+"tmp.torrent"
                else:
                    target="/tmp/"+"tmp.torrent"
                ret=downloadfile(torrentFile,target)
                print "ret",ret
                from bencode import torrent_parser as tp
                import bencode, hashlib
                printD("target",target)
                data = tp.parse_torrent_file(target)
                #print "['info']",data['info']
                files=[]
                try:
                    files=data['info']['files']
                except:
                        printE()
                        files=[]
                    
 
                        name=data['info'].get('name',None)
                        length=data['info'].get('length','0')
                        if name:
                           files.append({'path':name,'length':length})
                           
                           




                try:
                    info_hash = hashlib.sha1(bencode.bencode(data[b"info"])).hexdigest()
                except:
                    printE()
                    info_hash=''
                

                extra['tHash']=info_hash
                extra['files']=files
                printD("files",files)
                printD("hash",info_hash)
                newfiles=[]
                
                for tfile in files:
                    path=str(tfile.get('path','')).replace("u'",'').replace("'","").replace("[","").replace("]","")
                    length=str(tfile.get('length',''))
                    try:
                        filestr=str(path)+" "+getmb(float(length))
                    except:
                        printE()
                        continue
                    newfiles.append(filestr)
                extra.update({'files':newfiles})    
                return extra
            except:
                printE()
                return extra        



    def informAboutGeoBlockingIfNeeded(self, country, onlyOnce=True):
        try: 
            if onlyOnce and self.isGeoBlockingChecked: return
        except Exception: 
            self.isGeoBlockingChecked = False
        sts, data = self.cm.getPage('https://dcinfos.abtasty.com/geolocAndWeather.php')
        if not sts: return
        try:
            data = json_loads(data.strip()[1:-1], '', True)
            if data['country'] != country:
                message = _('%s uses "geo-blocking" measures to prevent you from accessing the services from outside the %s Territory.') 
                GetIPTVNotify().push(message % (self.getMainUrl(), country), 'info', 5)
            self.isGeoBlockingChecked = True
        except Exception: printExc()

#####################################        
    def getDN(self,data, marker1, marker2, withMarkers = True):

        sts,NodesData=self.cm.ph.getDataBeetwenNodes(data, marker1, marker2, withMarkers)
        if sts:
            return NodesData
        else:
          printE()
          return ''
    def getSM(self,data, patron, index=0):
        try:
            matches = re.findall(patron, data, flags=re.DOTALL)
            return matches[index]
        except:
            return ""

    def getMM(self,text, pattern):
        return re.findall(pattern, text, re.DOTALL)
                    

    def getAIN(self,data, node1, node2, withNodes=True, numNodes=-1, caseSensitive=True):
      return self.cm.ph.getAllItemsBeetwenNodes(data, node1, node2, withNodes, numNodes, caseSensitive)

    def getSG(self,data, pattern, grupsNum=1, ignoreCase=False):
        return self.cm.ph.getSearchGroups(data, pattern, grupsNum=grupsNum, ignoreCase=ignoreCase)

    
    def getDRM(self,data, pattern1, pattern2, withMarkers=True):
        return self.cm.ph.getDataBeetwenReMarkers(data, pattern1, pattern2, withMarkers=withMarkers)

    def getDM(self,data, marker1, marker2, withMarkers=True, caseSensitive=True):
            sts,makersData=self.cm.ph.getDataBeetwenMarkers(data, marker1, marker2, withMarkers=withMarkers, caseSensitive=caseSensitive)
            if sts:
                return makersData
            else:
              printE()
              return ''
    def getAIM(self,data, marker1, marker2, withMarkers=True, caseSensitive=True):
          return self.cm.ph.getAllItemsBeetwenMarkers(data, marker1, marker2, withMarkers=withMarkers, caseSensitive=caseSensitive)
        
    def colorize(self,txt,selcolor='magenta',marker1="(",marker2=")"):
         printD('enigmaos()',enigmaos())  
         if getos()=="windows" or enigmaos()=="oe2.2" or not is_ascii(txt):
            return txt
        
         
         
         colors={'black':'\c00000000','white':'\c00??????','grey':'\c00808080',
                           
         'blue':'\c000000??','green':'\c0000??00','red':'\c00??0000','ivory':"\c0???????",
         'yellow':'\c00????00','cyan':'\\c0000????','magenta':'\c00??00??'}
         color=colors.get(selcolor,'\c0000????') 
         try:
            if not marker1 in txt :
                return color+" "+txt
            txtparts=txt.split(marker1)
            txt1=txtparts[0]
            txt2=txtparts[1]
            if marker2 in txt:
                txt3=txt2.split(marker2)[0]
            else:
                txt3=txt2 
            
            ftxt=txt1+" "+color+marker1+txt3+marker2
            printD("ftxt",ftxt)
            return ftxt
         except:
             printE()
             return txt
    def getcfPage(self, baseUrl, addParams = None, post_data = None):
        from CloudflareScraper import CloudflareScraper
        scraper=CloudflareScraper()
        try:
            if post_data :
                data=scraper.post(baseUrl,headers=addParams,data=post_data,verify=False).content
                sts=True
            else:
                 if addParams:
                    data=scraper.get(baseUrl,headers=addParams,verify=False).content
                 else:
                    data=scraper.get(baseUrl,verify=False).content 
                 sts=True
        except:
           printE()
           sts=False
           data=''
        printDBG("++++++++++++++++++++++++++++++++++++++++")
        printDBG("url: %s" % baseUrl)
        printDBG("sts: %s" % sts)
       
        printDBG("++++++++++++++++++++++++++++++++++++++++")
        return data
    def getPageCFProtection2(self,baseUrl, addParams = {}, post_data = None):
                
                import requests
                r=requests.session()
                data=r.get(baseUrl).content
               
                
                
                try:
                    if "'jschl-answer'" in data:
                        import cookielib
                        import time
                        from addonsParser.tsiplayer.libs import cfscrape      
                        scraper = cfscrape.create_scraper()
                        data = scraper.get(baseUrl).content
                        tokens, user_agent=cfscrape.get_tokens(self.MAIN_URL)
                        sts = True
                        cj = self.cm.getCookie(self.COOKIE_FILE)
                       
                        cook_dat=re.findall("'(.*?)'.*?'(.*?)'", str(tokens), re.S)          
                        for (cookieKey,cookieValue) in cook_dat:
                            cookieItem = cookielib.Cookie(version=0, name=cookieKey, value=cookieValue, port=None, port_specified=False, domain='.'+self.cm.getBaseUrl(baseUrl, True), domain_specified=True, domain_initial_dot=True, path='/', path_specified=True, secure=False, expires=time.time()+3600*48, discard=True, comment=None, comment_url=None, rest={'HttpOnly': None}, rfc2109=False)
                            cj.set_cookie(cookieItem)      

                        cj.save(self.COOKIE_FILE, ignore_discard = True)
                        return True,data
                except:
                    printD('erreur')
                return  False,None


    def getPage2(self, baseUrl, addParams = {}, post_data = None,cloudflare=False):
        if addParams == {}:
            addParams = dict(self.defaultParams)
        print "addParams",addParams
        origBaseUrl = baseUrl
        baseUrl = self.cm.iriToUri(baseUrl)
        if cloudflare:
            addParams['cloudflare_params'] = {'cookie_file':self.COOKIE_FILE, 'User-Agent':self.USER_AGENT}
            sts, data = self.getPageCFProtection2(baseUrl, addParams, post_data)

        else:
            
            sts, data = self.cm.getPage(baseUrl, addParams, post_data)



            
        printDBG("++++++++++++++++++++++++++++++++++++++++")
        printDBG("url: %s" % baseUrl)
        printDBG("sts: %s" % sts)
       
        printDBG("++++++++++++++++++++++++++++++++++++++++")
        if sts:
            return data
        else:
            return ''
        
    def getPageCFProtection(self,baseUrl, addParams = {}, post_data = None,cloudflare=True):
                
		
		if cloudflare=="auto":
                    data=self.getPage(baseUrl,addParams,post_data)
                    sts=True
                    if not '!![]+!![]' in data:
                        if data=='':
                            sts=False
                        return sts,data

                if cloudflare==False:
                   sts,data=self.getPage(baseUrl,addParams,post_data)
                   return sts,data
                
		if not post_data: post_data=(None,None)
		sts=False
		
                try:
                        printD("start resolving by anti-cf")
                        oRequestHandler = cRequestHandler(baseUrl)
                        if post_data:
                                oRequestHandler.setRequestType(cRequestHandler.REQUEST_TYPE_POST)
                                oRequestHandler.addParametersLine(post_data[0])			
                        data = oRequestHandler.request()
                        print "data1",data
                        sts = True
                        cook = GestionCookie().Readcookie('www_dpstream_top')
                        self.cookieHeader=str(cook)
                        if ';' in cook: cook_tab = cook.split(';')
                        else: cook_tab = cook
                        cj = self.cm.getCookie(self.COOKIE_FILE)
                        for item in cook_tab:
                                if '=' in item:			
                                        cookieKey, cookieValue = item.split('=')
                                        cookieItem = cookielib.Cookie(version=0, name=cookieKey, value=cookieValue, port=None, port_specified=False, domain='.'+self.cm.getBaseUrl(baseUrl, True), domain_specified=True, domain_initial_dot=True, path='/', path_specified=True, secure=False, expires=time.time()+3600*48, discard=True, comment=None, comment_url=None, rest={'HttpOnly': None}, rfc2109=False)
                                        cj.set_cookie(cookieItem)
                        cj.save(self.COOKIE_FILE, ignore_discard = True)

                        printDBG('ffffff'+self.cookieHeader)
                        sts=True
                except Exception, e:
                        printDBG('ERREUR:'+str(e))
                        printD("cloudflare falied")
                               
                        printE()       
                       
                        data=''
                        sts=False       
		return sts, data
		


    def getPage(self, baseUrl, addParams = {}, post_data = None,cloudflare=False):
        if addParams == {}:
            try:addParams = dict(self.defaultParams)
            except:addParams={}
        print "addParams",addParams
        origBaseUrl = baseUrl
        baseUrl = self.cm.iriToUri(baseUrl)
        if cloudflare==True or cloudflare=="auto":
            addParams['cloudflare_params'] = {'cookie_file':self.COOKIE_FILE, 'User-Agent':self.USER_AGENT}
            sts, data = self.getPageCFProtection(baseUrl, addParams, post_data,cloudflare)
        else:
            
            sts, data = self.cm.getPage(baseUrl, addParams, post_data)



            
        printDBG("++++++++++++++++++++++++++++++++++++++++")
        printDBG("url: %s" % baseUrl)
        printDBG("sts: %s" % sts)
       
        printDBG("++++++++++++++++++++++++++++++++++++++++")
        if sts:
            return data
        else:
            return ''
        



###################################################                               


    def listSubItems(self, cItem):
        printDBG("CBaseHostClass.listSubItems")
        self.currList = cItem['sub_items']

    def listToDir(self, cList, idx):
        return self.cm.ph.listToDir(cList, idx)
    
    def getMainUrl(self):
        return self.MAIN_URL
    
    def setMainUrl(self, url):
        if self.cm.isValidUrl(url):
            self.MAIN_URL = self.cm.getBaseUrl(url)
            return True
        return False
    
    def getFullUrl(self, url, currUrl=None):
        if currUrl == None or not self.cm.isValidUrl(currUrl):
            try:
                currUrl = self.getMainUrl()
            except Exception:
                currUrl = None
            if currUrl == None or not self.cm.isValidUrl(currUrl):
                currUrl = 'http://fake/'
        return self.cm.getFullUrl(url, currUrl)

    def getFullIconUrl(self, url, currUrl=None):
        if currUrl != None: return self.getFullUrl(url, currUrl)
        else: return self.getFullUrl(url)
        
    def getDefaulIcon(self, cItem=None):
        try:
            return getAppPath()+"/addons/"+self.DEFAULT_ICON_URL
           
        except Exception:
            pass
        return ''

    @staticmethod 
    def cleanhtml(str):
        try:
            txt=CParsingHelper.cleanHtmlStr(str)
        except:
            try:txt=cleanhtml2(str)
            except:return str
        return txt 
    @staticmethod 
    def getStr(v, default=''):
        if type(v) == type(u''): return v.encode('utf-8')
        elif type(v) == type(''):  return v
        return default
            
    def getCurrList(self):
        return self.currList

    def setCurrList(self, list):
        self.currList = list
        
    def getCurrItem(self):
        return self.currItem

    def setCurrItem(self, item):
        self.currItem = item

    def addDir2(self, params):
        params['type'] = 'category'
        self.currList.append(params)
        return self.currList
        
    def addMore(self, params):
        params['type'] = 'more'
        self.currList.append(params)
        return
        
    def addVideo(self, params):
        params['type'] = 'video'
        self.currList.append(params)
        return
        
    def addAudio(self, params):
        params['type'] = 'audio'
        self.currList.append(params)
        return
    
    def addPicture(self, params):
        params['type'] = 'picture'
        self.currList.append(params)
        return
        
    def addData(self, params):
        params['type'] = 'data'
        self.currList.append(params)
        return
  
    def addArticle(self, params):
        params['type'] = 'article'
        self.currList.append(params)
        return
    
    def addMarker(self, params):
        params['type'] = 'marker'
        self.currList.append(params)
        return
    
    def listsHistory(self, baseItem={'name': 'history', 'category': 'Wyszukaj'}, desc_key='plot', desc_base='' ):
        list = self.history.getHistoryList()
        for histItem in list:
            plot = ''
            try:
                if type(histItem) == type({}):
                    pattern     = histItem.get('pattern', '')
                    search_type = histItem.get('type', '')
                    if '' != search_type: plot = desc_base + _(search_type)
                else:
                    pattern     = histItem
                    search_type = None
                params = dict(baseItem)
                params.update({'title': pattern, 'search_type': search_type,  desc_key: plot})
                self.addDir(params)
            except Exception: printExc()
            
    def getFavouriteData(self, cItem):
        try:
            return json_dumps(cItem)
        except Exception: 
            printExc()
        return ''
        
    def getLinksForFavourite(self, fav_data):
        try:
            if self.MAIN_URL == None:
                self.selectDomain()
        except Exception: 
            printExc()
        links = []
        try:
            cItem = json_loads(fav_data)
            links = self.getLinksForItem(cItem)
        except Exception: printExc()
        return links
        
    def setInitListFromFavouriteItem(self, fav_data):
        try:
            if self.MAIN_URL == None:
                self.selectDomain()
        except Exception: 
            printExc()
        try:
            params = json_loads(fav_data)
        except Exception: 
            params = {}
            printExc()
            return False
        self.currList.append(params)
        return True
        
    def getLinksForItem(self, cItem):
        return self.getLinksForVideo(cItem)
    
    def handleService(self, index, refresh=0, searchPattern='', searchType=''):
        self.moreMode = False
        if 0 == refresh:
            if len(self.currList) <= index:
                return
            if -1 == index:
                self.currItem = { "name": None }
            else:
                self.currItem = self.currList[index]
        if 2 == refresh: # refresh for more items
            printDBG(">> endHandleService index[%s]" % index)
            # remove item more and store items before and after item more
            self.beforeMoreItemList = self.currList[0:index]
            self.afterMoreItemList = self.currList[index+1:]
            self.moreMode = True
            if -1 == index:
                self.currItem = { "name": None }
            else:
                self.currItem = self.currList[index]
    
    def endHandleService(self, index, refresh):
        print 'self.currListmmm',self.currList
        printD('self.currList',self.currList)
        self.TSaddDir(self.currList)
        if 2 == refresh: # refresh for more items
            currList = self.currList
            self.currList = self.beforeMoreItemList
            for item in currList:
                if 'more' == item['type'] or (item not in self.beforeMoreItemList and item not in self.afterMoreItemList):
                    self.currList.append(item)
            self.currList.extend(self.afterMoreItemList)
            self.beforeMoreItemList = []
            self.afterMoreItemList  = []
            
        self.moreMode = False
####
class Addon:

    def __init__(self, id = None):
        
        
           
           self.plugin_path=AppPath+"/addons/"+id
           print "self.plugin_path",self.plugin_path
           self.path=self.plugin_path


    def getLocalizedString(self, idx = ' '):
        if True:
            xfile = self.path + '/resources/language/English/strings.xml'
            if os.path.exists(xfile) == False:
                xfile = self.path + '/resources/language/english/strings.xml'
                if os.path.exists(xfile) == False:
                    xfile = self.plugin_path + '/resources/defaults/strings.xml'
            tree = xml.etree.cElementTree.parse(xfile)
            root = tree.getroot()
        try:
            for string in root.iter('string'):
                id = string.get('id')
                text = string.text
                if int(id) == int(idx):
                    xtxt = text
                    return xtxt

        except:
            for string in root.getiterator('string'):
                id = string.get('id')
                text = string.text
                if int(id) == int(idx):
                    xtxt = text
                    return xtxt

    def getSetting(self, id = None):
        item = id
        xfile = self.path + '/resources/settings.xml'
        print "xfile2",xfile
        if not os.path.exists(xfile):
            return None
        else:
            f = open(xfile, 'r')
            xfile2 = f.read()
            f.close()
            if '&' in xfile2:
                xfile2 = xfile2.replace('&', 'AxNxD')
                f2 = open('/tmp/TSmedia/temp.xml', 'w')
                f2.write(xfile2)
                f2.close()
                cmd = "mv '/tmp/TSmedia/temp.xml' " + xfile
                os.system(cmd)
            try:
                tree = xml.etree.cElementTree.parse(xfile)
            except:
                printE()
                return None

            root = tree.getroot()
            
            try:
                for setting in root.iter('setting'):
                    
                    type = setting.get('type')
                    print "type2",type
                    print "id2",id
                    
                    if type == 'bool':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt
                    elif type == 'action':
                        idx = setting.get('label')
                        action = setting.get('action')
                        if idx == item:
                            xtxt = action
                            return xtxt
                    elif type == 'text':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt
                    elif type == 'enum':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            ix = default
                            return ix
                    elif type == 'folder':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt
                    elif type == 'labelenum':
                        idx = setting.get('id')
                        print "idx2",idx
                        print "item2",item
                        default = setting.get('default')
                        values = setting.get('values')
                        if idx == item:
                            vals = values.split('|')
                            
                            #xtxt = vals[-1]
                            return default
                    elif type == 'number':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt
                    elif type == 'select':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt

            except:
                for setting in root.getiterator('setting'):
                    type = setting.get('type')
                    if type == 'bool':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt
                    elif type == 'action':
                        idx = setting.get('label')
                        action = setting.get('action')
                        if idx == item:
                            xtxt = action
                            return xtxt
                    elif type == 'text':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt
                    elif type == 'enum':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            ix = default
                            return ix
                    elif type == 'folder':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt
                    elif type == 'labelenum':
                        idx = setting.get('id')
                        values = setting.get('values')
                        if idx == item:
                            vals = values.split('|')
                            n = len(vals) - 1
                            xtxt = vals[n]
                            return xtxt
                    elif type == 'number':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt
                    elif type == 'select':
                        idx = setting.get('id')
                        default = setting.get('default')
                        if idx == item:
                            xtxt = default
                            return xtxt

            
            return None

    def getSetting1(self, id = id):
        xfile = self.path + '/resources/settings.xml'
        if not os.path.exists(xfile):
            return ''
        
        
        xmlText = open(xfile).read()       
       
        if '&' in xmlText:
            xmlText = xmlText.replace('&', 'AxNxD')
            f2 = open(plugin_path+'/tmp/temp.xml', 'w')
            f2.write(xmlText)
            f2.close()
            cmd = "mv '/tmp/temp.xml' " + xfile
            os.system(cmd)
        try:
            tree = xml.etree.cElementTree.parse(xfile)
            root = tree.getroot()
            
        except Exception as error:
            printE()
            print "error",str(error)
            return ''       
        
        i = 0
       
        for setting in root.iter('setting'):
            sid=setting.attrib.get("id",'')
            if sid==id:
                return setting.attrib.get("default",'')
            
                    



    def getSetting2(self, id = id):
        xfile = self.path + '/resources/settings.xml'
        if not os.path.exists(xfile):
            return '',''
        
        
        xmlText = open(xfile).read()       
       
        if '&' in xmlText:
            xmlText = xmlText.replace('&', 'AxNxD')
            f2 = open(plugin_path+'/tmp/temp.xml', 'w')
            f2.write(xmlText)
            f2.close()
            cmd = "mv '/tmp/temp.xml' " + xfile
            os.system(cmd)
        try:
            tree = xml.etree.cElementTree.parse(xfile)
            root = tree.getroot()
            
        except Exception as error:
            printE()
            print "error",str(error)
            return '',''       
        
        i = 0
       
        for setting in root.iter('setting'):
            sid=setting.attrib.get("id",'')
            if sid==id:
                return setting.attrib.get('label',''),setting.attrib.get("default",'')
            
            

    def setSetting(self, setting_id, value):
        """Sets a script setting."""
        if value is None:
            return False
        else:
            settings_xml = self.path + '/resources/settings.xml'
            if settings_xml is None:
                return False
            tree = xml.etree.cElementTree.parse(settings_xml)
            root = tree.getroot()
            for setting in root.iter('setting'):
                id = setting.get('id')
                if setting_id == id:
                    try:
                        setting.set('default', value)
                        tree.write(settings_xml)
                        return True
                    except:
                        return False

            return False
            return

    def openSettings(self, arg = None):
        """get all settings."""
        settings_xml = self.path + '/resources/settings.xml'
        tree = xml.etree.cElementTree.parse(settings_xml)
        root = tree.getroot()
        i = 0
        list = []
        for setting in root.iter('setting'):
            list.append((i, setting.attrib))
            i = i + 1

        return list

    def getAddonInfo(self, item):
        cachefold = None
        try:
            myfile = file('/tmp/TSmedia/xbmc.txt')
            icount = 0
            for line in myfile.readlines():
                cachefold = line
                break

        except:
            pass

        if cachefold is None:
            try:
                cachefold = sys.argv[3]
            except:
                cachefold = '/media/hdd'

        profile = cachefold + '/xbmc/profile/addon_data/' + str(self.id)
        cmd = 'mkdir -p ' + profile
        os.system(cmd)
        xfile = self.path + '/addon.xml'
        if not os.path.exists(xfile):
            return
        else:
            tree = xml.etree.cElementTree.parse(xfile)
            root = tree.getroot()
            version = str(root.get('version'))
            author = str(root.get('provider-name'))
            name = str(root.get('name'))
            id = str(root.get('id'))
            if item == 'path':
                return self.path
            if item == 'Path':
                return self.path
            if item == 'version':
                return version
            if item == 'author':
                return author
            if item == 'name':
                return name
            if item == 'id':
                return id
            if item == 'profile':
                return profile
            return 'xxx'
    
#####################useful TSmedia functions
def printE(msg=''):
    printD("===============================================")
    printD("                   EXCEPTION                   ")
    printD("===============================================")
    msg = msg + ': \n%s' % traceback.format_exc()
    traceback.print_exc(file=sys.stdout)
    printD("Error",msg)
    printD("===============================================")

def printD(label='', Ddata='' ):
        Ddata=str(Ddata)
        label=str(label)
    
   
        try:
            caller_name = getcaller_name() 
            f = open(log_file, 'a')
            
            f.write(caller_name+":"+label+'->'+Ddata + '\n')
            f.close
        except Exception:
            print("======================EXC printDBG======================")
            print("Log: %s" % traceback.format_exc())
            print("========================================================")
            try:
                msg = '%s' % traceback.format_exc()
                f = open(log_file, 'a')
                f.write(Ddata + '\n')
                f.close
            except Exception:
                print("======================EXC printDBG======================")
                print("logII: %s" % traceback.format_exc())
                print("========================================================")




def getimage_basename(webfile):
           try:
                if webfile.startswith('http'):
       
                        image_basenames = webfile.split("/")
                        image_basename=image_basenames[-2]+image_basenames[-1]
                       
                    
                else:
                    image_basename = webfile
                   
                   
                return image_basename
           except:
                return webfile

def getmainitem_image():
    try:
        imagefile='/tmp/TSmedia/mimage'
        image=open(imagefile).read()
        return image

    except:
        return ''
def supported(hostname):##mfaraj
    hostname=hostname.lower()
    try:
        from urlresolver.supservers import supported_servers  
        
        if supported_servers.has_key(hostname):
            supported=True
        else:
            supported =False
        return supported    
   
    except:
        printE()
        return False
def getserver_image(server):
    default_path=sys.argv[0]
    
    try:
        
        image_dir=os.path.dirname(default_path)
        image=os.path.join(image_dir, "img")
        image=image+"/"+server+".png"
        if  os.path.exists(image):
           
            pass
        else:
            image=plugin_path+"/interface/servers/"+server+".png"
            if  os.path.exists(image):
                pass
            else:            
               image=os.path.join(image_dir,'icon.png')
    except:
         image=os.path.join(image_dir,'icon.png')
    return image    
def cleanhtml2(raw_html):

    def replaceSpecialCharacters(sString):
        return sString.replace('\\/','/').replace('&amp;','&').replace('\xc9','E').replace('&#8211;', '-').replace('&#038;', '&').replace('&rsquo;','\'').replace('\r','').replace('\n','').replace('\t','').replace('&#039;',"'").replace('&quot;','"').replace('&gt;','>').replace('&lt;','<').replace('&nbsp;','')

    
    cleanr = re.compile('<.*?>')
    cleantext = re.sub(cleanr, '', raw_html)
    
    return replaceSpecialCharacters(cleantext)

def cleanTitle(title):
    title = title.replace('&lt;', '<').replace('&gt;', '>').replace('&amp;', '&').replace('&#039;', "'").replace('&quot;', '"').replace('&szlig;', '\xc3\x9f').replace('&ndash;', '-')
    title = title.replace('&Auml;', '\xc3\x84').replace('&Uuml;', '\xc3\x9c').replace('&Ouml;', '\xc3\x96').replace('&auml;', '\xc3\xa4').replace('&uuml;', '\xc3\xbc').replace('&ouml;', '\xc3\xb6')
    title = title.strip()
    return title
    
def getdebug_mode():
    debugmode='user'
    debugmode_file = '/tmp/TSmedia/debugmode'
    if os.path.exists(debugmode_file):
        try:
            debugmode = open(debugmode_file).read()
            return debugmode
        except:
            pass
    else:
        return debugmode
    return debugmode

def getcaller_name():
    try:
        import inspect
        import os
        frame = inspect.currentframe()
        frame = frame.f_back.f_back
        code = frame.f_code
        calling_module = os.path.basename(code.co_filename)
        return calling_module
    except:
        return ''
def cfresolve(url_page = None):
    
    if url_page:
        CBaseAddon=CBaseAddonClass({'cookie':'cooke.cookie'})
        sts,data = CBaseAddon.getPageCFProtection(url_page, addParams = {}, post_data = None)
        return data
def cfdownloadImage(url = None,images_chachepath=None,localfile=None):
    ofile=''
    printD("mahmoudone","mahmoudone")
    if url is None or url.strip() == '':
        return ''
    else:
        if 'ExQ' in url:
            url.replace('ExQ', '=')
        if getos() == 'windows':
            path = 'd:\\tmp'
        else:
            path = images_chachepath
        printD("localfile",localfile) 
        if url and url.startswith('http'):
            try:
                if localfile is None:
                    filename = url.split('/')[-1]
                    ofile = os.path.join(path, filename)

                else:
                    ofile=localfile
                if os.path.exists(ofile):
                    return ofile
                try:
                    r = cfresolve(url)
                    with open(ofile, 'wb') as f:
                        f.write(r)
                    f.close()
                    return ofile
                except:
                    printE()
                    pass

            except:
                printE()

        return ofile
        


def downloadImage(url = None,images_chachepath=None,localfile=None):
    ofile=True

    if url is None or url.strip() == '':
        return ''
    else:
        if 'ExQ' in url:
            url.replace('ExQ', '=')
        if getos() == 'windows':
            path = 'd:\\tmp'
        else:
            path = images_chachepath
       
       
        if url and url.startswith('http'):
            try:
                if localfile is None:
                    filename = url.split('/')[-1]
                    ofile = os.path.join(path, filename)

                else:
                    ofile=localfile

                if os.path.exists(ofile):
                     
                    return ofile
                r = requests.get(url, timeout=0.5,verify=False)
                if r.status_code == 200:
                    with open(ofile, 'wb') as f:
                        f.write(r.content)
                    f.close()
                    
                    return ofile
            except:
                printE()
            
        return ofile
        return


def get_youtube_link(value):
    """
    Examples:
    - http://youtu.be/SA2iWivDJiE
    - http://www.youtube.com/watch?v=_oPAwA_Udwc&feature=feedu
    - http://www.youtube.com/embed/SA2iWivDJiE
    - http://www.youtube.com/v/SA2iWivDJiE?version=3&amp;hl=en_US
    -'plugin://plugin.video.youtube/?action=play_video&amp;videoid=FBBLhRgrw0o'
    """
    from urlparse import urlparse
    vid = None
    if value is None:
        return
    else:
        value = value.strip()
        if value.startswith('plugin://'):
            try:
                vid = value.split('=')[value.count('=')]
            except:
                return

        else:
            query = urlparse(value)
            if query.hostname == 'youtu.be':
                vid = query.path[1:]
            elif query.hostname in ('www.youtube.com', 'youtube.com'):
                if query.path == '/watch':
                    p = parse_qs(query.query)
                    vid = p['v'][0]
                if query.path[:7] == '/embed/':
                    vid = query.path.split('/')[2]
                if query.path[:3] == '/v/':
                    vid = query.path.split('/')[2]
                    
        if vid is not None:            
           return 'plugin://plugin.video.youtube/?action=play_video&videoid=%s' % vid
        else:
           return        
def is_ascii(s):
    return all(ord(c) < 128 for c in s)
def downloadfile(url = None, target = ''):
    try:
        import requests
        s=requests.Session()
        r = s.get(url, timeout=10, verify=False)
        if r.status_code == 200:
            with open(target, 'wb') as f:
                f.write(r.content)
            f.close()
            return True
    except:
        printE()
        return False  
def getmb(b):##torrent
    try:
      return str(round(b/(1024*1024),2))+"MB"
    except:
        printE()
        return ''
